;==========
;DIALOGS
;==========
dialog nickComp_greeting {
  title nickComp $nickComp_ver
  size -1 -1 151 129
  option dbu
  icon 1, 2 1 146 81, nickComp_promo.png, 0
  text nickComp $nickComp_ver has been successfully loaded!, 2, 4 88 144 8, center
  button "OK", 3, 61 113 37 12, ok
  check "View help file", 4, 57 99 45 10
}
dialog nickcomp_setup {
  title Nick Completer version $nickComp_ver
  size -1 -1 160 95
  option dbu
  icon 1, 106 5 51 15,  nickComp_logo.png, 0
  check "Enable Nick Completion", 2, 5 8 82 10, push
  edit "NickName", 4, 4 70 152 10, autohs
  edit "", 5, 76 47 10 10, limit 1 center
  text "Postfix Character:", 6, 5 48 67 8
  box "Setup", 7, 1 0 158 94
  combo 8, 76 35 79 36, size vsbar drop
  text "Formatting Preset:", 9, 5 37 67 8
  text "Style:", 10, 5 62 31 7
  button "OK", 12, 119 10 20 6, hide ok cancel
  button "Save", 13, 40 62 24 7
  text "Preview:", 14, 5 22 25 8
  icon 15, 33 22 124 8
  button "Help", 16, 91 62 28 7
  button "Delete", 17, 66 62 24 7
  button "Preview", 3, 120 62 28 7
  check "Always strip color (automatically done on mode +c chans)", 11, 5 82 151 10
}
dialog nickcomp_sel {
  title "NickComp"
  size -1 -1 55 35
  option dbu
  combo 1, 2 10 50 50, size drop
  edit "",4, 2 10 50 50, result hide
  button "OK", 3, 8 22 37 8, ok
  box "Select Nick", 2, 0 0 54 33
}

on *:DIALOG:nickComp_greeting:init:0:{
  did -c nickComp_greeting 4
}
on *:DIALOG:nickComp_greeting:sclick:3:{
  if ($did(nickComp_greeting,4).state) { run $scriptdirnickComp 2.hlp }
}
on *:DIALOG:nickcomp_setup:init:0:{
  if (%nickcomp_on == 1) { did -c nickcomp_setup 2 }
  did -a nickcomp_setup 5 %nickcomp_nchar
  %counter = 1
  unset %nickcomp_styles
  while (%counter <= $hget(nickcomp_styles,0).item) {
    %nickcomp_styles = $addtok(%nickcomp_styles,$hget(nickcomp_styles,%counter).item,44)
    inc %counter
  }
  didtok nickcomp_setup 8 44 %nickcomp_styles
  did -c nickcomp_setup 8 $findtok(%nickcomp_styles,$hfind(nickcomp_styles,%nickcomp_formatstr,1).data,1,44)
  did -r nickcomp_setup 4
  did -a nickcomp_setup 4 $hget(nickcomp_styles,$did(8))
  did -g nickcomp_setup 15 $formatstr_preview($hget(nickcomp_styles,$did(8)))
  if (%nickComp_stripcolor) { did -c nickcomp_setup 11 }
}
on *:DIALOG:nickcomp_setup:sclick:2:{
  %nickcomp_on = $did(2).state
}
on *:DIALOG:nickcomp_setup:sclick:3:{
  did -g nickcomp_setup 15 $formatstr_preview($did(4))
}
on *:DIALOG:nickcomp_setup:edit:5:{
  if ($did(5)) { %nickcomp_nchar = $did(5) }
}
on *:DIALOG:nickcomp_setup:sclick:8:{
  did -r nickcomp_setup 4
  did -a nickcomp_setup 4 $hget(nickcomp_styles,$did(8))
  did -g nickcomp_setup 15 $formatstr_preview($hget(nickcomp_styles,$did(8)))
  %nickcomp_formatstr = $hget(nickcomp_styles,$did(8))
}
on *:DIALOG:nickcomp_setup:sclick:11:{
  set %nickcomp_stripcolor $did(nickcomp_setup,11).state
  did -g nickcomp_setup 15 $formatstr_preview($hget(nickcomp_styles,$did(nickcomp_setup,8)))
}
on *:DIALOG:nickcomp_setup:sclick:13:{
  %nickcomp_newstyle.name = $?="Save Style As..."
  :nickcomp_checkvalidname
  if ($hfind(nickcomp_styles,%nickcomp_newstyle.name,1)) { 
    if (!$?!="This will overwrite the current saved style. Continue?") { return }
  }
  elseif ($numtok(%nickcomp_newstyle.name,32) > 1) {
    %nickcomp_newstyle.name = $?="Name cannot contain spaces. Please select another."
    goto nickcomp_checkvalidname
  }
  elseif (!%nickcomp_newstyle.name) { return }
  hadd nickcomp_styles %nickcomp_newstyle.name $did(nickcomp_setup,4)
  %counter = 1
  unset %nickcomp_styles
  while (%counter <= $hget(nickcomp_styles,0).item) {
    %nickcomp_styles = $addtok(%nickcomp_styles,$hget(nickcomp_styles,%counter).item,44)
    inc %counter
  }
  %nickcomp_formatstr = $did(4)
  did -r nickcomp_setup 8
  didtok nickcomp_setup 8 44 %nickcomp_styles
  did -c nickcomp_setup 8 $findtok(%nickcomp_styles,$hfind(nickcomp_styles,%nickcomp_formatstr,1).data,1,44)
  did -r nickcomp_setup 4
  did -a nickcomp_setup 4 $hget(nickcomp_styles,$did(8))
  did -g nickcomp_setup 15 $formatstr_preview($hget(nickcomp_styles,$did(8)))
  hsave -bo nickcomp_styles $scriptdirnickcomp.stp
}
on *:DIALOG:nickcomp_setup:sclick:16:{
  run $scriptdirnickcomp 2.hlp
}
on *:DIALOG:nickcomp_setup:sclick:17:{
  if ($did(nickcomp_setup,8) != Plain) {
    if (!$?!="Really delete this style?") { halt }
    hdel nickcomp_styles $did(nickcomp_setup,8)
    %counter = 1
    unset %nickcomp_styles
    while (%counter <= $hget(nickcomp_styles,0).item) {
      %nickcomp_styles = $addtok(%nickcomp_styles,$hget(nickcomp_styles,%counter).item,44)
      inc %counter
    }
    %nickcomp_formatstr = $did(nickcomp_setup,4)
    %nickcomp_formatstr = $hget(nickcomp_styles,Plain)
    did -r nickcomp_setup 8
    didtok nickcomp_setup 8 44 %nickcomp_styles
    did -c nickcomp_setup 8 $findtok(%nickcomp_styles,$hfind(nickcomp_styles,%nickcomp_formatstr,1).data,1,44)
    did -r nickcomp_setup 4
    did -a nickcomp_setup 4 $hget(nickcomp_styles,$did(nickcomp_setup,8))
    did -g nickcomp_setup 15 $formatstr_preview($hget(nickcomp_styles,$did(nickcomp_setup,8)))
  }
  else { .echo -q $?!="The Plain style is the default, it may not be deleted" }
}
on *:DIALOG:nickcomp_sel:init:0:{
  didtok nickcomp_sel 1 44 %nickcomp %nickcomp_nlist
  did -c nickcomp_sel 1 1
  did -a nickcomp_sel 4 $did(nickcomp_sel,1)
}
on *:DIALOG:nickcomp_sel:sclick:1:{
  did -r nickcomp_sel 4
  echo $did(nickcomp_sel,1,0)
  did -a nickcomp_sel 4 $did(nickcomp_sel,1).seltext
}

;==========
;MENUS
;==========
menu status,menubar,channel,nicklist,query {
  Nick Completer
  .Settings:dialog -m nickcomp_setup nickcomp_setup
  .Say what you're running!:nickcomp_ad
  .Open Help File:run $scriptdirnickComp 2.hlp
  .-
  .Revert style hash table to defaults:{ $if($input(This will erase any custom styles you may have set. Continue?,8,nickComp $nickComp_ver)) {
      hfree nickcomp_styles
      nickComp_makedefstylehash
      .echo -q $input(Styles have been reset,4,nickComp $nickComp_ver)
    }
  }
  .-
  .Reload Script:reload -rs $script
  .Unload Script:unload -rs $script
}

;==========
;REMOTE
;==========
on *:LOAD:{
  if (!%nickcomp_on) { set %nickcomp_on 1 }
  if (!%nickcomp_nchar) { set %nickcomp_nchar : }
  nickcomp_makedefstylehash
  if (!%nickcomp_formatstr) { set %nickcomp_formatstr $hget(nickcomp_styles,Phoenix) }
  dialog -m nickComp_greeting nickComp_greeting
}
on *:START:{
  ;window @debug
  debug.print nickComp $nickComp_ver addon for mIRC 5.91 initializing...
  debug.print ________________________________________________
  debug.print Checking mIRC version...
  if ($version < 5.91) {
    debug.print Error - nickComp requires mIRC version 5.91 or higher, version $version found instead
    .echo -q $input(nickComp is designed for mIRC 5.91 or higher. mIRC $version was found instead. $&
      Proper operation of this script cannot be guaranteed.,4,nickComp $nickComp_ver)
  }
  debug.print mIRC version $version running Windows $os in $bits bit mode
  debug.print Checking for Style Pack Hash Table File...
  if ($exists($scriptdirnickcomp.stp)) {
    if (!$hget(nickcomp_styles)) { hmake nickcomp_styles 10 }
    hload -b nickcomp_styles $scriptdirnickcomp.stp
  }
  else {
    debug.print Not found... creating new from defaults
    nickcomp_makedefstylehash
    hload -b nickcomp_styles $scriptdirnickcomp.stp
  }
  debug.print All OK!
  debug.print ________________________________________________

}
on *:INPUT:#:{
  if (%nickcomp_on == 1) {
    unset %nickcomp_nlist
    %counter = 1
    if ($right($1,1) == %nickcomp_nchar) { 
      while (%counter <= $nick(#,0)) {
        if (($left($nick(#,%counter),$len($gettok($1,1,$asc(%nickcomp_nchar)))) == $gettok($1,1,$asc(%nickcomp_nchar))) && ($nick(#,%counter) != $me)) {
          %nickcomp_nlist = $addtok(%nickcomp_nlist,$nick(#,%counter),44)
        }

        inc %counter
      }
      if ($numtok(%nickcomp_nlist,44) == 1) {
        if (!%nickcomp_formatstr) {
          say %nickcomp_nlist $+ : $2-
        }
        else {
          if ($regex($chan(#).mode,/\+[^ ]*?c/)) {
            say $strip($parse_formatstr(%nickcomp_nlist,%nickcomp_formatstr),c) $+ %nickcomp_nchar $2-
          }
          else {
            say $parse_formatstr(%nickcomp_nlist,%nickcomp_formatstr) $+ %nickcomp_nchar $2-
          }
        }
        halt
      }
      elseif ($numtok(%nickcomp_nlist,44) > 1) {
        %nickcomp_nick = $dialog(nickcomp_sel,nickcomp_sel)
        if (!%nickcomp_formatstr) {
          say %nickcomp_nick $+ : $2-
        }
        else {
          if ($regex($chan(#).mode,/\+[^ ]*?c/)) {
            say $strip($parse_formatstr(%nickcomp_nlist,%nickcomp_formatstr),c) $+ %nickcomp_nchar $2-
          }
          else {
            say $parse_formatstr(%nickcomp_nlist,%nickcomp_formatstr) $+ %nickcomp_nchar $2-
          }
        }
        halt

      }
    }
  }
}

;==========
;ALIASES
;==========
alias nickcomp_ver { return 2.1 }
alias nickcomp_ad { me is running nickComp version $nickcomp_ver nick completion addon for mIRC 5.91+ 32bit }
alias nickcomp_multi {
  return $dialog(nickcomp_sel,nickcomp_sel)
}
alias nickcomp_makedefstylehash {
  hmake nickcomp_styles 10
  hadd nickcomp_styles Plain &u&w&u
  hadd nickcomp_styles FirstBold &b&f&b&u&m&l&u
  hadd nickcomp_styles RedBrackets &c04(&c&w&c04)&c
  hadd nickcomp_styles GreenBrackets &c09(&c&w&c09)&c
  hadd nickcomp_styles BlueBrackets &c12(&c&w&c12)&c
  hadd nickcomp_styles Sylver &c07{&c15&b&f&b&u&c10&m&l&u&c07}&c
  hadd nickcomp_styles Phoenix &b&c00&b&c14:&c15&b:&b&c05&c04\&c15&b.&b&c14.&b{u:&c04&f&c15:u}{l:&b&m&b:l}{u:&c04&l&c15:u}&b&c14.&c15&b.&b&c04/&c05&c15&b:&b&c14:&b&c00&b&c
  hsave -bo nickcomp_styles $scriptdirnickcomp.stp
}

alias parse_formatstr {
  ; $1 == word to format
  ; $2 == format string
  ;FORMATTING CHARS
  ;&B              Bold
  ;&U              Underline
  ;&C[ n ] [,n2 ]  Color n [, BG Color n2 ]
  ;&R              Reverse
  ;&W              entire word
  ;&F              first letter of word
  ;&L              last letter of word
  ;&M              middle chars of word
  ;^n prefix       cycle format on and off every n chars
  ;^E              end format cycle

  %formattedstr = $replace($2,&B,,&U,,&C,,&R,,&O,,&W,$1,&F,$left($1,1),&L,$right($1,1),&M,$mid($1,2,$calc($len($1) - 2)))
  %formattedstr = $regex_stylefn(%formattedstr)
  if (%nickComp_stripcolor) { %formattedstr = $strip(%formattedstr,c) }
  return %formattedstr $+ 
}

alias -l ^R {
  ;RandomStyle

  %counter = 1
  unset %randomstyle_output
  while (%counter <= $len($1-)) {
    %randomstyle_code = $gettok(>>,$rand(1,3),62)
    ;$iif(%randomstyle_code == , %randomstyle_code = %randomstyle_code $+ $rand(0,15))
    %randomstyle_output = %randomstyle_output $+ %randomstyle_code $+ $iif($mid($1-,%counter,1) == $chr(32),$chr(1),$mid($1-,%counter,1))
    inc %counter
  }
  return $replace(%randomstyle_output,$chr(1),$chr(32)) $+ 
}

alias -l ^C {
  ;CycleStyle

  %counter = 1
  unset %cyclestyle_output
  while (%counter <= $len($1-)) {
    %cyclestyle_code = $gettok(>>,$calc((%counter % 3) + 1),62)
    %cyclestyle_output = %cyclestyle_output $+ %cyclestyle_code $+ $iif($mid($1-,%counter,1) == $chr(32),$chr(1),$mid($1-,%counter,1))
    inc %counter
  }
  return $replace(%cyclestyle_output,$chr(1),$chr(32)) $+ 
}

alias -l ^M {
  ;RandomCase

  %counter = 1
  unset %randomcase_output
  while (%counter <= $len($1-)) {
    %randomcase = $rand(1,2)
    if (%randomcase == 1) {
      %randomcase_output = %randomcase_output $+ $iif($mid($1-,%counter,1) == $chr(32),$chr(1),$upper($mid($1-,%counter,1)))
    }
    else {
      %randomcase_output = %randomcase_output $+ $iif($mid($1-,%counter,1) == $chr(32),$chr(1),$lower($mid($1-,%counter,1)))
    }
    inc %counter
  }
  return $replace(%randomcase_output,$chr(1),$chr(32))
}

alias -l ^N {
  ;CycleCase

  %counter = 1
  unset %cyclecase_output
  while (%counter <= $len($1-)) {
    inc %cyclecase
    if ($calc(%cyclecase % 2) == 1) {
      %cyclecase_output = %cyclecase_output $+ $iif($mid($1-,%counter,1) == $chr(32),$chr(1),$upper($mid($1-,%counter,1)))
    }
    else {
      %cyclecase_output = %cyclecase_output $+ $iif($mid($1-,%counter,1) == $chr(32),$chr(1),$lower($mid($1-,%counter,1)))
    }
    inc %counter
  }
  return $replace(%cyclecase_output,$chr(1),$chr(32))
}

alias -l ^U {
  return $upper($1-)
}

alias -l ^L {
  return $lower($1-)
}

alias -l ^E {
  ;l33tstyle

  %leetstyle =  $replacecs($1-, $&
    AE,$chr(198), $&
    f,F, F,ph, $&
    ck,x0r, $&
    cks,x0rz $&
    )
  %leetstyle = $replacecs(%leetstyle, $&
    a,A, A,4, $&
    B,$chr(223), $&
    c,$chr(162), C,$chr(169), $&
    d,D, D,| $+ $chr(41), $&
    e,E, E,3, $&
    H,$chr(124) $+ - $+ $chr(124), $&
    i,I, I,1, $&
    K,$chr(124) $+ $chr(139), $&
    l,L, L,$chr(163), $&
    M,$chr(40) $+ \/ $+ $chr(41), $&
    N,$chr(124) $+ \ $+ $chr(124), $&
    o,$chr(248), O,0, $&
    p,P, P,$chr(182), $&
    Q,$chr(40) $+ $chr(44) $+ $chr(41), $&
    S,5, $&
    t,+, T,7, $&
    u,$chr(181), U,$chr(124) $+ _ $+ $chr(124), $&
    W,`//, $&
    x,$chr(215) $&
    )
  return %leetstyle
}

alias -l regex_stylefn {
  .echo -q $regsub($1-,/\\}/g,$chr(1),%stylefn)
  %stylefn = $replace(%stylefn, $chr(32),$chr(5))
  while ($regex(%stylefn,/{([CRULMNE]):(.*?):\1}/i)) {
    .echo -q $regsub(%stylefn,/{([CRULMNE]):(.*?):\1}/gi,$chr(32) $+ $cr $lf $+ \1(\2) $cr $+ $chr(32),%stylefn)
  }
  return $replace($eval($replace(%stylefn, $cr,$!+, $lf,$!^, $chr(1),$chr(125)),2),$chr(5),$chr(32))
}

alias -l formatstr_preview {
  ;modded considerably from ZeeG's $xd.p previewing alias in xServ

  var %prv = nickcomp.bmp
  var %prvstr = $parse_formatstr($did(nickComp_setup,8),$1-)
  window -phf @xserv 0 0 248 16
  $iif(%prvstr,drawtext -bpc @xserv $colour(normal) $colour(background) Verdana -8 1 1 248 16 %prvstr)
  drawsave @xserv %prv
  window -c @xserv
  return %prv
}

alias -l debug.print {
  if ($window(@debug)) { aline @debug $1- }
}
